'use strict';

module.exports = imageReference;

var normalize = require('normalize-uri');
var failsafe = require('../failsafe');

/* Transform a reference to an image. */
function imageReference(h, node) {
  var def = h.definition(node.identifier);
  var props = {src: normalize((def && def.url) || ''), alt: node.alt};

  if (def && def.title != null) {
    props.title = def.title;
  }

  return failsafe(h, node, def) || h(node, 'img', props);
}
